<template>
    <div class="types">
        <div class="types--fn">{{ fn }}</div>
        <span v-if="!property">(</span><div v-for="(arg, i) of args"
                                            :key="arg.name"
                                            class="types--arg">
                <span class="types--arg-type">{{ arg.type }}</span>
                <span class="types--arg-name">&nbsp;${{ arg.name }}</span>
                <span v-if="i < args.length - 1">,&nbsp;</span>
            </div><span v-if="!property">)</span>:
        <div class="types--return">
            {{ r }}
        </div>
    </div>
</template>

<script setup>
import { defineProps } from 'vue';

defineProps({
    fn:       String,
    r:        {
        type:    String,
        default: 'void',
    },
    args:     {
        type:    Array,
        default: () => [],
    },
    property: {
        type:    Boolean,
        default: false,
    },
});
</script>

<style scoped>
.types {
    display:    inline-flex;
    font-size:  1rem;
    color:      #525156;
    width:      100%;
    overflow-x: auto;
}

.types--fn {
    display: inline-flex;
    color:   #9ac7b8;
}

.types--arg-type {
    color: #a21e59;
}

.types--arg-name {
    color:       #846f57;
}

.types--return {
    margin-left: 0.4rem;
    display:     inline-flex;
    color:       #9b7c31;
}
</style>